<template>
  <base-dialog :show="!!error" title="Wystąpił błąd!" @close="handleError">
    {{ error }}
  </base-dialog>
  <base-card>
    <div v-if="isLoading">
      <base-spinner></base-spinner>
    </div>
    <div v-else-if="!isLoading">
      <h1>Nowa praca zaliczeniowa</h1>
      <form @submit.prevent="submitForm" class="formStyling">
        <div class="form-control" :class="{ invalid: !topic.isValid }">
          <label for="topic">Temat</label>
          <input
            type="text"
            id="topic"
            v-model.trim="topic.val"
            @blur="clearValidity('topic')"
          />
          <p v-if="!topic.isValid">Uzupełnij temat.</p>
        </div>
        <div class="form-control" :class="{ invalid: !description.isValid }">
          <label for="comment">Opis</label>
          <textarea
            id="comment"
            rows="2"
            v-model.trim="description.val"
            @blur="clearValidity('description')"
          ></textarea>
          <p v-if="!description.isValid">Uzupełnij opis.</p>
        </div>
        <div class="form-control" :class="{ invalid: !date.isValid }">
          <label for="date">Data</label>
          <input
            type="date"
            id="date"
            v-model.trim="date.openDate"
            @blur="clearValidity('date')"
            class="date"
          />
          -
          <input
            type="date"
            id="date"
            v-model.trim="date.closeDate"
            @blur="clearValidity('date')"
            class="date"
          />
          <p v-if="!date.isValid">Wybierz poprawną datę otwarcia i datę zamknięcia.</p>
        </div>
        <div class="button">
          <base-button>Dodaj pracę zaliczeniową</base-button>
        </div>
      </form>
    </div>
  </base-card>
</template>

<script setup>
import { ref } from "vue";
import { useStore } from "vuex";
import { useRouter } from "vue-router";

const store = useStore();
const router = useRouter();

const topic = ref({
  val: "",
  isValid: true,
});
const description = ref({
  val: "",
  isValid: true,
});
const date = ref({
  openDate: "",
  closeDate: "",
  isValid: true,
});

const formIsValid = ref(true);
const error = ref(null);
const isLoading = ref(false);

function handleError() {
  error.value = null;
}

function clearValidity(input) {
  this[input].isValid = true;
}

function validateForm() {
  formIsValid.value = true;
  if (topic.value.val === "") {
    topic.value.isValid = false;
    formIsValid.value = false;
    topic.value.val = "";
  }
  if (description.value.val === "") {
    description.value.isValid = false;
    formIsValid.value = false;
    description.value.val = "";
  }
  if (new Date(date.value.openDate) < new Date(todayDate) || new Date(date.value.closeDate) <= new Date(date.value.openDate)) {
    date.value.isValid = false;
    formIsValid.value = false;
    date.value.openDate = todayDate;
    date.value.closeDate = todayDate;
  }
}

async function submitForm() {
  validateForm();

  if (!formIsValid.value) {
    return;
  }

  isLoading.value = true;
  try {
    await store.dispatch("addWork", {
      topic: topic.value.val,
      description: description.value.val,
      openDate: date.value.openDate,
      closeDate: date.value.closeDate,
      uuId: userUuId,
    })
    await router.replace("/works");
  } catch (er) {
    error.value = er.message || "Nie udało się dodać pracy zaliczeniowej.";
  }
  isLoading.value = false;
}

const todayDate = new Date().toISOString().substring(0, 10);
date.value.openDate = todayDate;
date.value.closeDate = todayDate;

const userUuId = store.getters.userId;
</script>

<style scoped>
.date {
  width: 20%;
  display: inline-block;
}
</style>
